Package: seqLogo
Title: Sequence logos for DNA sequence alignments
Version: 1.78.0
Authors@R: 
    c(person(given="Oliver", family="Bembom", 
             role = c("aut"), email = "oliver.bembom@gmail.com"),
      person(given="Robert", family="Ivanek", 
             role=c("aut", "cre"), email="robert.ivanek@unibas.ch", 
             comment=c(ORCID="0000-0002-8403-056X")))
Description: seqLogo takes the position weight matrix of a DNA sequence
        motif and plots the corresponding sequence logo as introduced
        by Schneider and Stephens (1990).
LazyLoad: yes
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.1.2
Imports: stats4, grDevices
Depends: R (>= 4.2), methods, grid
Suggests: knitr, BiocStyle, rmarkdown, testthat
BugReports: https://github.com/ivanek/seqLogo/issues
VignetteBuilder: knitr
Collate: AllClasses.R AllGenerics.R pwm.R seqLogo.R
License: LGPL (>= 2)
biocViews: SequenceMatching
Repository: https://bioc-release.r-universe.dev
Date/Publication: 2026-04-28 12:32:11 UTC
RemoteUrl: https://github.com/bioc/seqLogo
RemoteRef: RELEASE_3_23
RemoteSha: a7902a4e87196a3c1d58a70df3942d10e94c8fff
NeedsCompilation: no
Packaged: 2026-04-29 13:49:49 UTC; root
Author: Oliver Bembom [aut],
  Robert Ivanek [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-8403-056X>)
Maintainer: Robert Ivanek <robert.ivanek@unibas.ch>
Built: R 4.6.0; ; 2026-04-29 13:52:24 UTC; unix

<img src="vignettes/seqLogo-logo.png" align="right" alt="" width="120" />

# _seqLogo_ - Plotting the position weight matrix of a DNA/RNA sequence motif as a sequence logo

## Software status

<!-- badges: start -->
[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
[![How long since the package was first in a released Bioconductor version](https://bioconductor.org/shields/years-in-bioc/seqLogo.svg)](https://bioconductor.org/packages/seqLogo) 
[![Bioconductor-devel Downloads](https://bioconductor.org/shields/downloads/devel/seqLogo.svg)](https://bioconductor.org/packages/stats/bioc/seqLogo/)
[![Support site activity in last 6 months: agged questions/avg. answers per question/avg. comments per question/accepted answers, or 0 if no tagged posts](https://bioconductor.org/shields/posts/seqLogo.svg)](https://support.bioconductor.org/t/seqLogo/)
[![GitHub issues](https://img.shields.io/github/issues/ivanek/seqLogo)](https://github.com/ivanek/seqLogo/issues)
<!-- badges: end -->

&nbsp;

|                     | Bioc ([release](https://bioconductor.org/packages/release/bioc/html/seqLogo.html)) | Bioc ([devel](https://bioconductor.org/packages/devel/bioc/html/seqLogo.html)) |
|:--------------------|----------------------------------------------------------------------------:|--------------------------------------------------------------------------------:|
| OS                  | [![Platforms](https://bioconductor.org/shields/availability/release/seqLogo.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/seqLogo/) | [![Platforms](https://bioconductor.org/shields/availability/devel/seqLogo.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/seqLogo/) |
| Bioc Last Update    | [![Bioconductor-release Last Commit](https://bioconductor.org/shields/lastcommit/release/bioc/seqLogo.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/seqLogo/) | [![Bioconductor-devel Last Commit](https://bioconductor.org/shields/lastcommit/devel/bioc/seqLogo.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/seqLogo/) |
| Bioc Status         | [![Bioconductor-release Build Status](https://bioconductor.org/shields/build/release/bioc/seqLogo.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/seqLogo) | [![Bioconductor-devel Build Status](https://bioconductor.org/shields/build/devel/bioc/seqLogo.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/seqLogo) |
| GitHub Last Commit  | [![GitHub last commit (Bioconductor-release)](https://img.shields.io/github/last-commit/ivanek/seqLogo/RELEASE_3_14)](https://github.com/ivanek/seqLogo/tree/RELEASE_3_14) | [![GitHub last commit (Bioconductor-devel)](https://img.shields.io/github/last-commit/ivanek/seqLogo/master)](https://github.com/ivanek/seqLogo/tree/master/) |
| GitHub Actions      | [![R build status](https://github.com/ivanek/seqLogo/workflows/R-CMD-check-bioc/badge.svg?branch=RELEASE_3_14)](https://github.com/ivanek/seqLogo/actions) | [![R build status](https://github.com/ivanek/seqLogo/workflows/R-CMD-check-bioc/badge.svg?branch=master)](https://github.com/ivanek/seqLogo/actions) |
| Coverage            | [![Codecov.io (Bioconductor-release)](https://codecov.io/github/ivanek/seqLogo/coverage.svg?branch=RELEASE_3_14)](https://codecov.io/gh/ivanek/seqLogo/branch/RELEASE_3_14) | [![Codecov.io (Bioconductor-devel)](https://codecov.io/github/ivanek/seqLogo/coverage.svg?branch=master)](https://codecov.io/github/ivanek/seqLogo) |

## Authors

- Oliver Bembom
- Robert Ivanek

## Overview

seqLogo takes the position weight matrix of a DNA sequence motif and plots 
the corresponding sequence logo as introduced by Schneider and Stephens (1990).

## Installation

#### Release version

```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("seqLogo", version = "release")
```

#### Developmental version

```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("seqLogo", version = "devel")
```

#### Github

```
if (!requireNamespace("remotes", quietly = TRUE))
    install.packages("remotes")
remotes::install_github("ivanek/seqLogo")
```

## Usage

For detailed instructions check the package vignette 
([release](https://bioconductor.org/packages/release/bioc/vignettes/seqLogo/inst/doc/seqLogo.pdf) 
or 
[developmental](https://bioconductor.org/packages/devel/bioc/vignettes/seqLogo/inst/doc/seqLogo.html) 
version). Or the GitHub.io [page](https://ivanek.github.io/seqLogo/).

## Citation 

```
citation("seqLogo")
```

- Oliver Bembom and Robert Ivanek (2020). seqLogo: Sequence logos for DNA sequence alignments.

#' An S4 class to represent a PWM matrix.
#'
#' @description An object of class `'pwm'` represents the alphabet*width
#'   position weight matrix of a sequence motif. In case of DNA sequence motif,
#'   the entry in row i, column j gives the probability of observing nucleotide
#'   `c('A','C','G','T')[i]` in position j of the motif.
#'
#' @slot pwm matrix. The position weight matrix.
#' @slot width numeric. The width of the motif.
#' @slot ic numeric. The information content (IC).
#' @slot alphabet character. The sequence alphabet. Currently, only 'DNA' and
#'   'RNA' is supported.
#' @slot consensus character. The consensus sequence.
#'
#' @return `pwm-class` object with slots: `pwm`, `width`, `ic` and `alphabet`.
#'
#' @author Oliver Bembom
#'
#' @aliases
#' pwm
#' ic
#' consensus
#' alphabet
#'
#' @examples
#' mFile <- system.file("extdata/pwm1", package = "seqLogo")
#' m <- read.table(mFile)
#' p <- makePWM(m)
#' #
#' # slot access
#' pwm(p)
#' ic(p)
#' consensus(p)
#' @export
setClass("pwm", representation(
    pwm = "matrix", width = "numeric", ic = "numeric",
    alphabet = "character", consensus = "character"
))

## helpers --------------------------------------------------------------------

#' Rescales the values (internal)
#'
#' @param x numeric. Original values.
#' @param to numeric. Output range,  vector of length two.
#'
#' @return numeric. Rescaled values. Same length as `x`
#' @keywords internal
#' @noRd
.rescale <- function(x, to = c(0.025, 0.975)) {
    from <- range(x, na.rm = TRUE, finite = TRUE)
    (x - from[1]) / diff(from) * diff(to) + to[1]
}


#' Check if the colors are valid
#'
#' @param x character. Vectors of colors to check.
#'
#' @return logical. Same length as `x`.
#' @importFrom grDevices col2rgb
#' @keywords internal
#' @noRd
.isValidColor <- function(x) {
    vapply(x, function(X) {
        tryCatch(is.matrix(col2rgb(X)), error = function(e) FALSE)
    }, FUN.VALUE = logical(1), USE.NAMES = FALSE)
}

## letters --------------------------------------------------------------------


#' Draw A letter
#'
#' @param x.pos numeric. X position for the letter.
#' @param y.pos numeric. Y position for the letter.
#' @param ht numeric. Height of the letter.
#' @param wt numeric. Width of the letter.
#' @param fill character. Color of the letter (polygon shape fill)
#' @param id integer. Shape id.
#'
#' @return list. List with 'x', 'y' coordinates, 'id' and 'fill' of the polygon
#' shape (letter).
#'
#' @keywords internal
#' @noRd
letterA <- function(x.pos, y.pos, ht, wt, fill = "#61D04F", id = NULL) {
    x <- c(0, 4, 6, 2, 0, 4, 6, 10, 8, 4, 3.2, 6.8, 6.4, 3.6, 3.2)
    y <- c(0, 10, 10, 0, 0, 10, 10, 0, 0, 10, 3, 3, 4, 4, 3)
    x <- 0.1 * x
    y <- 0.1 * y

    x <- .rescale(x)
    x <- x.pos + wt * x
    y <- y.pos + ht * y

    if (is.null(id)) {
        id <- c(rep(1L, 5), rep(2L, 5), rep(3L, 5))
    } else {
        id <- c(rep(id, 5), rep(id + 1L, 5), rep(id + 2L, 5))
    }

    fill <- rep(fill, 3) # green

    list(x = x, y = y, id = id, fill = fill)
}

#' Draw T letter
#'
#' @param x.pos numeric. X position for the letter.
#' @param y.pos numeric. Y position for the letter.
#' @param ht numeric. Height of the letter.
#' @param wt numeric. Width of the letter.
#' @param fill character. Color of the letter (polygon shape fill)
#' @param id integer. Shape id.
#'
#' @return list. List with 'x', 'y' coordinates, 'id' and 'fill' of the polygon
#' shape (letter).
#'
#' @keywords internal
#' @noRd
letterT <- function(x.pos, y.pos, ht, wt, fill = "#DF536B", id = NULL) {
    x <- c(0, 10, 10, 6, 6, 4, 4, 0)
    y <- c(10, 10, 9, 9, 0, 0, 9, 9)
    x <- 0.1 * x
    y <- 0.1 * y

    x <- .rescale(x)
    x <- x.pos + wt * x
    y <- y.pos + ht * y

    if (is.null(id)) {
        id <- rep(1, 8)
    } else {
        id <- rep(id, 8)
    }

    fill <- rep(fill, 1) # red

    list(x = x, y = y, id = id, fill = fill)
}


#' Draw U letter
#'
#' @param x.pos numeric. X position for the letter.
#' @param y.pos numeric. Y position for the letter.
#' @param ht numeric. Height of the letter.
#' @param wt numeric. Width of the letter.
#' @param fill character. Color of the letter (polygon shape fill)
#' @param id integer. Shape id.
#'
#' @return list. List with 'x', 'y' coordinates, 'id' and 'fill' of the polygon
#' shape (letter).
#'
#' @keywords internal
#' @noRd
letterU <- function(x.pos, y.pos, ht, wt, fill = "#DF536B", id = NULL) {
    angle1 <- seq(pi / 2, pi, length = 100)
    angle2 <- seq(pi, 1.5 * pi, length = 100)
    x.l1 <- 0.5 + 0.5 * sin(angle1)
    y.l1 <- 0.5 + 0.5 * cos(angle1)
    x.l2 <- 0.5 + 0.5 * sin(angle2)
    y.l2 <- 0.5 + 0.5 * cos(angle2)

    x.l <- c(x.l1, x.l2)
    y.l <- c(y.l1, y.l2)

    x.i1 <- 0.5 + 0.3 * sin(angle1)
    y.i1 <- 0.5 + 0.35 * cos(angle1)
    x.i1 <- x.i1[y.i1 <= max(y.l1)]
    y.i1 <- y.i1[y.i1 <= max(y.l1)]
    y.i1[1] <- max(y.l1)

    x.i2 <- 0.5 + 0.3 * sin(angle2)
    y.i2 <- 0.5 + 0.35 * cos(angle2)

    x.i <- c(x.i1, x.i2)
    y.i <- c(y.i1, y.i2)

    x <- c(x.l, 0, 0.2, 0.2, rev(x.i), 0.8, 0.8, 1, 1)
    y <- c(y.l, 1, 1, 0.5, rev(y.i), 0.5, 1, 1, 0.85)

    x <- .rescale(x)
    x <- x.pos + wt * x
    y <- y.pos + ht * y

    if (is.null(id)) {
        id <- rep(1, length(x))
    } else {
        id <- rep(id, length(x))
    }

    fill <- rep(fill, 1) # blue

    list(x = x, y = y, id = id, fill = fill)
}

#' Draw C letter
#'
#' @param x.pos numeric. X position for the letter.
#' @param y.pos numeric. Y position for the letter.
#' @param ht numeric. Height of the letter.
#' @param wt numeric. Width of the letter.
#' @param fill character. Color of the letter (polygon shape fill)
#' @param id integer. Shape id.
#'
#' @return list. List with 'x', 'y' coordinates, 'id' and 'fill' of the polygon
#' shape (letter).
#'
#' @keywords internal
#' @noRd
letterC <- function(x.pos, y.pos, ht, wt, fill = "#2297E6", id = NULL) {
    angle1 <- seq(0.3 + pi / 2, pi, length = 100)
    angle2 <- seq(pi, 1.5 * pi, length = 100)
    x.l1 <- 0.5 + 0.5 * sin(angle1)
    y.l1 <- 0.5 + 0.5 * cos(angle1)
    x.l2 <- 0.5 + 0.5 * sin(angle2)
    y.l2 <- 0.5 + 0.5 * cos(angle2)

    x.l <- c(x.l1, x.l2)
    y.l <- c(y.l1, y.l2)

    x <- c(x.l, rev(x.l))
    y <- c(y.l, 1 - rev(y.l))

    x.i1 <- 0.5 + 0.35 * sin(angle1)
    y.i1 <- 0.5 + 0.35 * cos(angle1)
    x.i1 <- x.i1[y.i1 <= max(y.l1)]
    y.i1 <- y.i1[y.i1 <= max(y.l1)]
    y.i1[1] <- max(y.l1)

    x.i2 <- 0.5 + 0.35 * sin(angle2)
    y.i2 <- 0.5 + 0.35 * cos(angle2)

    x.i <- c(x.i1, x.i2)
    y.i <- c(y.i1, y.i2)

    x1 <- c(x.i, rev(x.i))
    y1 <- c(y.i, 1 - rev(y.i))

    x <- c(x, rev(x1))
    y <- c(y, rev(y1))

    x <- .rescale(x)
    x <- x.pos + wt * x
    y <- y.pos + ht * y

    if (is.null(id)) {
        id <- rep(1, length(x))
    } else {
        id <- rep(id, length(x))
    }

    fill <- rep(fill, 1) # blue

    list(x = x, y = y, id = id, fill = fill)
}

#' Draw G letter
#'
#' @param x.pos numeric. X position for the letter.
#' @param y.pos numeric. Y position for the letter.
#' @param ht numeric. Height of the letter.
#' @param wt numeric. Width of the letter.
#' @param fill character. Color of the letter (polygon shape fill)
#' @param id integer. Shape id.
#'
#' @return list. List with 'x', 'y' coordinates, 'id' and 'fill' of the polygon
#' shape (letter).
#'
#' @keywords internal
#' @noRd
letterG <- function(x.pos, y.pos, ht, wt, fill = "#F5C710", id = NULL) {
    angle1 <- seq(0.3 + pi / 2, pi, length = 100)
    angle2 <- seq(pi, 1.5 * pi, length = 100)
    x.l1 <- 0.5 + 0.5 * sin(angle1)
    y.l1 <- 0.5 + 0.5 * cos(angle1)
    x.l2 <- 0.5 + 0.5 * sin(angle2)
    y.l2 <- 0.5 + 0.5 * cos(angle2)

    x.l <- c(x.l1, x.l2)
    y.l <- c(y.l1, y.l2)

    x <- c(x.l, rev(x.l))
    y <- c(y.l, 1 - rev(y.l))

    x.i1 <- 0.5 + 0.35 * sin(angle1)
    y.i1 <- 0.5 + 0.35 * cos(angle1)
    x.i1 <- x.i1[y.i1 <= max(y.l1)]
    y.i1 <- y.i1[y.i1 <= max(y.l1)]
    y.i1[1] <- max(y.l1)

    x.i2 <- 0.5 + 0.35 * sin(angle2)
    y.i2 <- 0.5 + 0.35 * cos(angle2)

    x.i <- c(x.i1, x.i2)
    y.i <- c(y.i1, y.i2)

    x1 <- c(x.i, rev(x.i))
    y1 <- c(y.i, 1 - rev(y.i))

    x <- c(x, rev(x1))
    y <- c(y, rev(y1))

    h1 <- max(y.l1)
    r1 <- max(x.l1)

    h1 <- 0.4

    x.add <- c(r1, 0.5, 0.5, r1 - 0.2, r1 - 0.2, r1, r1)
    y.add <- c(h1, h1, h1 - 0.1, h1 - 0.1, 0, 0, h1)

    if (is.null(id)) {
        id <- c(rep(1, length(x)), rep(2, length(x.add)))
    } else {
        id <- c(rep(id, length(x)), rep(id + 1, length(x.add)))
    }

    x <- c(rev(x), x.add)
    y <- c(rev(y), y.add)

    x <- .rescale(x)
    x <- x.pos + wt * x
    y <- y.pos + ht * y


    fill <- rep(fill, 2) # orange/yellow

    list(x = x, y = y, id = id, fill = fill)
}

## addLetter ------------------------------------------------------------------

#' Add letter (polygon shape ) to existing list of shapes.
#'
#' @param letters list. List with 'x', 'y' coordinates, 'id' and 'fill' of the polygon shape (letter).
#' @param which character. Letter to be added.
#' @param x.pos numeric. X position for the letter.
#' @param y.pos numeric. Y position for the letter.
#' @param ht numeric. Height of the letter.
#' @param wt numeric. Width of the letter.
#' @param fill character. Color of the letter (polygon shape fill)
#' @param id integer. Shape id.
#'
#' @return list. List with 'x', 'y' coordinates, 'id' and 'fill' of the polygon
#' shape (letter).
#'
#' @keywords internal
#' @noRd
addLetter <- function(letters, which, x.pos, y.pos, ht, wt, fill) {
    if (which == "A") {
        letter <- letterA(x.pos, y.pos, ht, wt, fill = fill["A"])
    } else if (which == "C") {
        letter <- letterC(x.pos, y.pos, ht, wt, fill = fill["C"])
    } else if (which == "G") {
        letter <- letterG(x.pos, y.pos, ht, wt, fill = fill["G"])
    } else if (which == "T") {
        letter <- letterT(x.pos, y.pos, ht, wt, fill = fill["T"])
    } else if (which == "U") {
        letter <- letterU(x.pos, y.pos, ht, wt, fill = fill["U"])
    } else {
        stop(sprintf("\"which\" must be one of %s", paste(names(fill), collapse = ", ")))
    }

    letters$x <- c(letters$x, letter$x)
    letters$y <- c(letters$y, letter$y)

    lastID <- ifelse(is.null(letters$id), 0, max(letters$id))
    letters$id <- c(letters$id, lastID + letter$id)
    letters$fill <- c(letters$fill, as.character(letter$fill)) # remove name
    letters
}


## plotting -------------------------------------------------------------------

#' Plot a sequence logo for a given position weight matrix
#'
#' @description This function takes the alphabet*width position weight matrix of
#'   a sequence motif and plots the corresponding sequence logo.
#'
#' @usage
#' seqLogo(pwm, ic.scale=TRUE, xaxis=TRUE, yaxis=TRUE, xfontsize=15, yfontsize=15,
#'         fill=c(A='#61D04F', C='#2297E6', G='#F5C710', T='#DF536B'))
#'
#' @param pwm numeric. The alphabet*width position weight matrix.
#' @param ic.scale logical. If TRUE, the height of each column is proportional to its information content. Otherwise, all columns have the same height.
#' @param xaxis logical. If TRUE, an X-axis will be plotted.
#' @param yaxis logical. If TRUE, a Y-axis will be plotted.
#' @param xfontsize numeric. Font size to be used for the X-axis.
#' @param yfontsize numeric.  Font size to be used for the Y-axis.
#' @param fill character. Fill color to be used for the letters. Must be a named character vector of length equal to number of rows in `pwm` slot and names identical to its rownames.
#'
#' @return NULL.
#'
#' @author Oliver Bembom
#'
#' @import grid
#' @import methods
#'
#' @examples
#' mFile <- system.file("extdata/pwm1", package = "seqLogo")
#' m <- read.table(mFile)
#' p <- makePWM(m)
#' seqLogo(p)
#' @export
seqLogo <- function(pwm, ic.scale = TRUE, xaxis = TRUE, yaxis = TRUE, xfontsize = 15,
                    yfontsize = 15, fill = c(A = "#61D04F", C = "#2297E6", G = "#F5C710", T = "#DF536B")) {
    if (is.data.frame(pwm) || is.matrix(pwm)) {
        pwm <- makePWM(pwm)
    }

    if (!is(pwm, "pwm")) {
        stop("pwm must be of class pwm, matrix or data.frame")
    }

    # adjust default color setting if alphabet set to RNA
    if (pwm@alphabet == "RNA") {
        if ("T" %in% names(fill)) {
            names(fill)[which(names(fill) == "T")] <- "U"
        }
    }

    if (!is.character(fill) || length(fill) != nrow(pwm(pwm)) || !all(rownames(pwm(pwm)) %in%
        names(fill)) || !all(.isValidColor(fill))) {
        stop(
            "\"fill\" must be named character vector of length ",
            sprintf(
                "%d, with names %s (matching the rownames of pwm)",
                nrow(pwm(pwm)), paste(rownames(pwm(pwm)), collapse = ", ")
            ), "and valid colors as values"
        )
    }

    chars <- rownames(pwm(pwm))
    letters <- list(x = NULL, y = NULL, id = NULL, fill = NULL)
    npos <- ncol(pwm(pwm))


    if (ic.scale) {
        ylim <- 2
        ylab <- "Information content"
        facs <- ic(pwm)
    } else {
        ylim <- 1
        ylab <- "Probability"
        facs <- rep(1, npos)
    }

    wt <- 1
    x.pos <- 0
    for (j in seq_len(npos)) {
        column <- pwm(pwm)[, j]
        hts <- 0.95 * column * facs[j]
        letterOrder <- order(hts)

        y.pos <- 0
        for (i in seq_len(4)) {
            letter <- chars[letterOrder[i]]
            ht <- hts[letterOrder[i]]
            if (ht > 0) {
                  letters <- addLetter(letters, letter, x.pos, y.pos, ht, wt, fill)
              }
            y.pos <- y.pos + ht + 0.01
        }
        x.pos <- x.pos + wt
    }

    grid.newpage()
    bottomMargin <- ifelse(xaxis, 2 + xfontsize / 3.5, 2)
    leftMargin <- ifelse(yaxis, 2 + yfontsize / 3.5, 2)
    pushViewport(plotViewport(c(bottomMargin, leftMargin, 2, 2)))
    pushViewport(dataViewport(0:ncol(pwm(pwm)), 0:ylim, name = "vp1"))
    grid.polygon(
        x = unit(letters$x, "native"), y = unit(letters$y, "native"), id = letters$id,
        gp = gpar(fill = letters$fill, col = "transparent")
    )
    if (xaxis) {
        grid.xaxis(
            at = seq(0.5, ncol(pwm(pwm)) - 0.5), label = seq_len(ncol(pwm(pwm))),
            gp = gpar(fontsize = xfontsize)
        )
        grid.text("Position", y = unit(-3, "lines"), gp = gpar(fontsize = xfontsize))
    }
    if (yaxis) {
        grid.yaxis(gp = gpar(fontsize = yfontsize))
        grid.text(ylab, x = unit(-3, "lines"), rot = 90, gp = gpar(fontsize = yfontsize))
    }
    popViewport()
    popViewport()
}

setGeneric("pwm", function(pwm) standardGeneric("pwm"))

setGeneric("ic", function(pwm) standardGeneric("ic"))

setGeneric("consensus", function(pwm) standardGeneric("consensus"))

# setGeneric("alphabet", function(pwm) standardGeneric("alphabet"))

# setGeneric("seqLogo", signature(pwm="pwm"),
#            function(x, ic.scale=TRUE, xaxis=TRUE, yaxis=TRUE,
#                     xfontsize=15, yfontsize=15,
#                     fill=c(A="#61D04F", C="#2297E6", G="#F5C710", T="#DF536B"))
#              standardGeneric("seqLogo")
# )

mFile <- system.file("extdata/pwm1", package = "seqLogo")
dfDNA <- read.table(mFile)

## DNA
mDNA <- as.matrix(dfDNA)
rownames(mDNA) <- c("A", "C", "G", "T")
colnames(mDNA) <- seq_len(ncol(mDNA))

## RNA
mRNA <- mDNA
rownames(mRNA) <- c("A", "C", "G", "U")

## Amino Acid
mAA <- rbind(mDNA, matrix(0, nrow=16, ncol=ncol(mDNA)))
rownames(mAA) <- c("A", "C", "D", "E", "F", "G", "H", "I", "K", "L", 
                   "M", "N", "P", "Q", "R", "S", "T", "V", "W", "Y")

# default fills
fills = c(A = "#61D04F", C = "#2297E6", G = "#F5C710", T = "#DF536B")

## constructor ----------------------------------------------------------------

#' Constructing a pwm object
#'
#' @description This function constructs an object of class pwm from a matrix. It checks that the matrix has correct dimensions and that columns add up to 1.0.
#'
#' @param pwm matrix. Numerical matrix representing the position weight matrix.
#' @param alphabet character. The alphabet making up the sequence. Currently, only 'DNA' and 'RNA' is supported.
#'
#' @return An object of class pwm.
#'
#' @author Oliver Bembom
#'
#' @import grid
#' @import methods
#' @import stats4
#'
#' @examples
#' mFile <- system.file("extdata/pwm1", package = "seqLogo")
#' m <- read.table(mFile)
#' pwm <- makePWM(m)
#' @export
makePWM <- function(pwm, alphabet = "DNA") {
    if (is.data.frame(pwm)) {
          pwm <- as.matrix(pwm)
      }
    if (!is.matrix(pwm)) {
          stop("pwm must be a matrix or a dataframe")
      }

    if (!alphabet %in% c("DNA", "RNA", "AA")) {
          stop("alphabet must be either DNA, RNA or AA")
      }
    if (alphabet == "DNA") {
        if (nrow(pwm) != 4) {
              stop("PWM for DNA motifs must have 4 rows")
          }
        rownames(pwm) <- c("A", "C", "G", "T")
    } else if (alphabet == "RNA") {
        if (nrow(pwm) != 4) {
              stop("PWM for RNA motifs must have 4 rows")
          }
        rownames(pwm) <- c("A", "C", "G", "U")
    } else if (alphabet == "AA") {
        if (nrow(pwm) != 20) {
              stop("PWM for amino acid motifs must have 20 rows")
          }
        rownames(pwm) <- c(
            "A", "C", "D", "E", "F", "G", "H", "I", "K", "L", "M",
            "N", "P", "Q", "R", "S", "T", "V", "W", "Y"
        )
    }
    if (any(abs(1 - apply(pwm, 2, sum)) > 0.01)) {
        warning("Columns of PWM must add up to 1.0")
    }

    width <- ncol(pwm)
    colnames(pwm) <- seq_len(width)

    cons <- pwm2cons(pwm)
    ic <- pwm2ic(pwm)

    new("pwm", pwm = pwm, consensus = cons, ic = ic, width = width, alphabet = alphabet)
}
## class functions ------------------------------------------------------------

#' @param object object of `pwm-class`
#'
#' @describeIn pwm-class Shows the position weight matrix.
#'
#' @export
#'
setMethod("show", signature(object = "pwm"), function(object) {
    print(round(object@pwm, 4))
})

#' @param object object of `pwm-class`
#'
#' @describeIn pwm-class Prints the summary information about position weight
#'   matrix.
#'  
#' @export
#'
setMethod("summary", signature(object = "pwm"), function(object, ...) {
    cat("Position weight matrix:\n")
    print(round(object@pwm, 4))
    cat("\n\nInformation content:\n")
    print(round(object@ic, 4))
    cat("\n\nConsensus sequence:\n")
    print(object@consensus)
})

#' @param x object of `pwm-class`
#' @param y default (missing) for `plot` function
#' @param ... additional parameters for `plot` function
#'
#' @describeIn pwm-class Plots the sequence logo of the position weight matrix.
#' 
#' @export
#'
setMethod("plot", signature(x = "pwm"), function(x, y = "missing", ...) {
    seqLogo(x)
})


## getters --------------------------------------------------------------------

#' @param pwm  object of `pwm-class`
#' @describeIn pwm-class Access to 'pwm' slot
#' @export
setMethod("pwm", "pwm", function(pwm) pwm@pwm)

#' @param pwm  object of `pwm-class`
#' @describeIn pwm-class Access to 'ic' slot
#' @export
setMethod("ic", "pwm", function(pwm) pwm@ic)

#' @param pwm  object of `pwm-class`
#' @describeIn pwm-class Access to 'consensus' slot
#' @export
setMethod("consensus", "pwm", function(pwm) pwm@consensus)

# #' @param pwm object of `pwm-class` #' @describeIn pwm-class Access to
# 'alphabet' slot #' @export setMethod('alphabet', 'pwm', function(pwm)
# pwm@alphabet)

## helpers --------------------------------------------------------------------

#' Calculates information content profile from PWM
#'
#' @param pwm matrix. Position weight matrix.
#'
#' @return numeric. Vector of length identical to with of the 'pwm'.
#'
#' @keywords internal
#' @noRd
pwm2ic <- function(pwm) {
    if (!is.matrix(pwm) || !is.numeric(pwm)) {
        warning("pwm argument must be of class matrix (numeric)")
    }
    npos <- ncol(pwm)
    ic <- numeric(length = npos)
    for (i in seq_len(npos)) {
        ic[i] <- 2 + sum(vapply(pwm[, i], function(x) {
            if (x > 0) {
                x * log2(x)
            } else {
                0
            }
        }, FUN.VALUE = numeric(1)))
    }
    ic
}

#' Extracts consensus sequence from PWM
#'
#' @param pwm matrix. Position weight matrix.
#'
#' @return character. Consensus sequence pf the length identical to the width of 'pwm'.
#'
#' @keywords internal
#' @noRd
pwm2cons <- function(pwm) {
    if (!is.matrix(pwm) || !is.numeric(pwm)) {
        warning("pwm argument must be of class matrix")
    }
    letters <- rownames(pwm)
    paste(apply(pwm, 2, function(x) {
        letters[rev(order(x))[1]]
    }), collapse = "")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/pwm.R
\docType{class}
\name{pwm-class}
\alias{pwm-class}
\alias{pwm}
\alias{ic}
\alias{consensus}
\alias{alphabet}
\alias{show,pwm-method}
\alias{summary,pwm-method}
\alias{plot,pwm,ANY-method}
\alias{pwm,pwm-method}
\alias{ic,pwm-method}
\alias{consensus,pwm-method}
\title{An S4 class to represent a PWM matrix.}
\usage{
\S4method{show}{pwm}(object)

\S4method{summary}{pwm}(object, ...)

\S4method{plot}{pwm,ANY}(x, y = "missing", ...)

\S4method{pwm}{pwm}(pwm)

\S4method{ic}{pwm}(pwm)

\S4method{consensus}{pwm}(pwm)
}
\arguments{
\item{object}{object of \code{pwm-class}}

\item{...}{additional parameters for \code{plot} function}

\item{x}{object of \code{pwm-class}}

\item{y}{default (missing) for \code{plot} function}

\item{pwm}{object of \code{pwm-class}}
}
\value{
\code{pwm-class} object with slots: \code{pwm}, \code{width}, \code{ic} and \code{alphabet}.
}
\description{
An object of class \code{'pwm'} represents the alphabet*width
position weight matrix of a sequence motif. In case of DNA sequence motif,
the entry in row i, column j gives the probability of observing nucleotide
\code{c('A','C','G','T')[i]} in position j of the motif.
}
\section{Functions}{
\itemize{
\item \code{show,pwm-method}: Shows the position weight matrix.

\item \code{summary,pwm-method}: Prints the summary information about position weight
matrix.

\item \code{plot,pwm,ANY-method}: Plots the sequence logo of the position weight matrix.

\item \code{pwm,pwm-method}: Access to 'pwm' slot

\item \code{ic,pwm-method}: Access to 'ic' slot

\item \code{consensus,pwm-method}: Access to 'consensus' slot
}}

\section{Slots}{

\describe{
\item{\code{pwm}}{matrix. The position weight matrix.}

\item{\code{width}}{numeric. The width of the motif.}

\item{\code{ic}}{numeric. The information content (IC).}

\item{\code{alphabet}}{character. The sequence alphabet. Currently, only 'DNA' and
'RNA' is supported.}

\item{\code{consensus}}{character. The consensus sequence.}
}}

\examples{
mFile <- system.file("extdata/pwm1", package = "seqLogo")
m <- read.table(mFile)
p <- makePWM(m)
#
# slot access
pwm(p)
ic(p)
consensus(p)
}
\author{
Oliver Bembom
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwm.R
\name{makePWM}
\alias{makePWM}
\title{Constructing a pwm object}
\usage{
makePWM(pwm, alphabet = "DNA")
}
\arguments{
\item{pwm}{matrix. Numerical matrix representing the position weight matrix.}

\item{alphabet}{character. The alphabet making up the sequence. Currently, only 'DNA' and 'RNA' is supported.}
}
\value{
An object of class pwm.
}
\description{
This function constructs an object of class pwm from a matrix. It checks that the matrix has correct dimensions and that columns add up to 1.0.
}
\examples{
mFile <- system.file("extdata/pwm1", package = "seqLogo")
m <- read.table(mFile)
pwm <- makePWM(m)
}
\author{
Oliver Bembom
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqLogo.R
\name{seqLogo}
\alias{seqLogo}
\title{Plot a sequence logo for a given position weight matrix}
\usage{
seqLogo(pwm, ic.scale=TRUE, xaxis=TRUE, yaxis=TRUE, xfontsize=15, yfontsize=15,
        fill=c(A='#61D04F', C='#2297E6', G='#F5C710', T='#DF536B'))
}
\arguments{
\item{pwm}{numeric. The alphabet*width position weight matrix.}

\item{ic.scale}{logical. If TRUE, the height of each column is proportional to its information content. Otherwise, all columns have the same height.}

\item{xaxis}{logical. If TRUE, an X-axis will be plotted.}

\item{yaxis}{logical. If TRUE, a Y-axis will be plotted.}

\item{xfontsize}{numeric. Font size to be used for the X-axis.}

\item{yfontsize}{numeric.  Font size to be used for the Y-axis.}

\item{fill}{character. Fill color to be used for the letters. Must be a named character vector of length equal to number of rows in \code{pwm} slot and names identical to its rownames.}
}
\value{
NULL.
}
\description{
This function takes the alphabet*width position weight matrix of
a sequence motif and plots the corresponding sequence logo.
}
\examples{
mFile <- system.file("extdata/pwm1", package = "seqLogo")
m <- read.table(mFile)
p <- makePWM(m)
seqLogo(p)
}
\author{
Oliver Bembom
}
